﻿----------------------------------------------------------------------------------------------------
-- DroodFocus 4.1.3 - anchor
-- Meranannon - Discordia - Vol'jin (EU)
-- rev 1
----------------------------------------------------------------------------------------------------

local DF = DF_namespace
local nbAnchors = 7

-- initialisation frames
function DF:init_anchor_frame()
	
	-- mise a jour des positions des ancres par rapport a l'ancre global
	-- (pas de changement sur les version supérieure a la 4.1.4)
	if DF_config.configversion<415 then

		-- position de l'ancre 1
		tempx=DF_config["anchor1"].positionx
		tempy=DF_config["anchor1"].positiony	

		-- initialisation de l'ancre 0 a coté de l'ancre 1
		DF_config["anchor0"].positionx = tempx-32
		DF_config["anchor0"].positiony = tempy+32
		globalx=DF_config["anchor0"].positionx
		globaly=DF_config["anchor0"].positiony

		-- replacement des ancre 1 a 7 par rapport a l'ancre 0		
		for i = 1,nbAnchors do
			
			tempx=DF_config["anchor"..tostring(i)].positionx
			tempy=DF_config["anchor"..tostring(i)].positiony
			
			if (tempx==0 and tempy==0) then
				DF_config["anchor"..tostring(i)].positionx = -200
				DF_config["anchor"..tostring(i)].positiony = 0
			else
				DF_config["anchor"..tostring(i)].positionx = (tempx-globalx)
				DF_config["anchor"..tostring(i)].positiony = (tempy-globaly)
			end
			
		end

		DF_config["anchor0"].positionx = ( GetScreenWidth() * UIParent:GetEffectiveScale() )/2
		DF_config["anchor0"].positiony = ( GetScreenHeight() * UIParent:GetEffectiveScale() )/2

	end

	i=0
	
	-- global anchor
	if not DF.baseanchor then
		
		DF.baseanchor={}
		
		-- cadre principal
		DF.baseanchor.base = CreateFrame("FRAME","DF_anchor_BASE"..tostring(i),UIParent)

		-- la texture
		DF.baseanchor.frame = CreateFrame("FRAME","DF_anchor_FRAME"..tostring(i),DF.baseanchor.base)
		DF.baseanchor.framet = CreateFrame("FRAME","DF_anchor_FRAMEt"..tostring(i),DF.baseanchor.base)
		DF.baseanchor.overlay=CreateFrame("FRAME","DF_anchor_OVERLAY"..tostring(i),DF.baseanchor.base)
		DF.baseanchor.overlayTexture = DF.baseanchor.overlay:CreateTexture(nil,"BACKGROUND")
		DF.baseanchor.frameTexture = DF.baseanchor.framet:CreateTexture(nil,"BACKGROUND")
		DF.baseanchor.text = DF.baseanchor.overlay:CreateFontString("DF_ANCHORTEXT"..i,"ARTWORK")
		DF.baseanchor.base:EnableMouse(false)
		
		DF.baseanchor.overlay.numero=i
		
		DF.baseanchor.overlay:EnableMouse(false)				
		DF.baseanchor.overlay:SetScript("OnMouseDown",function(self,button)
			if button=="LeftButton" then
				DF.baseanchor.base:StartMoving()
			end
		end)
		DF.baseanchor.overlay:SetScript("OnMouseUp",function(self,button)
			if button=="LeftButton" then
		  		DF.baseanchor.base:StopMovingOrSizing()
		  		DF_config["anchor0"].positionx = DF:alignToGridX(self:GetLeft())
		  		DF_config["anchor0"].positiony = DF:alignToGridY(self:GetBottom())
		  		DF.baseanchor.base:ClearAllPoints()
		  		DF.baseanchor.base:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", DF_config["anchor0"].positionx, DF_config["anchor0"].positiony)
		  	end
		end)	
		DF.baseanchor.overlay:SetScript("OnEnter",function(self,button)
			if DF.configmode then
				GameTooltip:SetOwner(UIParent, "ANCHOR_TOPLEFT ",16,-16)
				GameTooltip:ClearLines()
				GameTooltip:AddLine("DROODFOCUS GLOBAL ANCHOR",1,1,0,nil)
				GameTooltip:AddLine(DF.locale["leftMB"],1,1,1,nil)
				GameTooltip:Show()		
			end		
		end)		
		DF.baseanchor.overlay:SetScript("OnLeave",function(self,button)
			if DF.configmode then GameTooltip:Hide() end
		end)		

	end
	
	local level = 0

		-- paramétres cadre principal
	DF.baseanchor.base:SetMovable(true)
	DF.baseanchor.base:SetWidth(32)
	DF.baseanchor.base:SetHeight(32)
	DF.baseanchor.base:ClearAllPoints()
	DF.baseanchor.base:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", DF_config["anchor"..tostring(i)].positionx, DF_config["anchor"..tostring(i)].positiony)
	
		-- paramétres cadre qui acceuil éléments
	DF.baseanchor.frame:SetMovable(true)
	DF.baseanchor.frame:SetWidth(DF_config["anchor"..tostring(i)].width)
	DF.baseanchor.frame:SetHeight(DF_config["anchor"..tostring(i)].height)
	DF.baseanchor.frame:ClearAllPoints()
	DF.baseanchor.frame:SetPoint("TOPLEFT", DF.baseanchor.base, "TOPLEFT", 0, 0)

		-- paramétres cadre qui acceuil éléments
	DF.baseanchor.framet:SetMovable(true)
	DF.baseanchor.framet:SetWidth(DF_config["anchor"..tostring(i)].width)
	DF.baseanchor.framet:SetHeight(DF_config["anchor"..tostring(i)].height)
	DF.baseanchor.framet:ClearAllPoints()
	DF.baseanchor.framet:SetPoint("TOPLEFT", DF.baseanchor.base, "TOPLEFT", 0, 0)
	
	-- paramétres overlay
	DF.baseanchor.overlay:SetMovable(false)
	DF.baseanchor.overlay:SetWidth(32)
	DF.baseanchor.overlay:SetHeight(32)
	DF.baseanchor.overlay:ClearAllPoints()
	DF.baseanchor.overlay:SetPoint("TOPLEFT", DF.baseanchor.frame, "TOPLEFT", 0, 0)
	DF.baseanchor.overlay:SetFrameLevel(255)

	-- paramétres texture
	DF.baseanchor.overlayTexture:SetTexCoord(0, 1, 0, 1)
	DF.baseanchor.overlayTexture:SetWidth(32)
	DF.baseanchor.overlayTexture:SetHeight(32)
	DF.baseanchor.overlayTexture:SetBlendMode("BLEND")
	DF.baseanchor.overlayTexture:ClearAllPoints()
	DF.baseanchor.overlayTexture:SetAllPoints(DF.baseanchor.overlay)
	DF.baseanchor.overlayTexture:SetTexture("Interface\\AddOns\\DroodFocus\\datas\\anchor.tga")

	-- paramétres texture
	DF.baseanchor.frameTexture:SetTexCoord(0, 1, 0, 1)
	DF.baseanchor.frameTexture:SetBlendMode(DF_config["anchor"..tostring(i)].mode)
	DF.baseanchor.frameTexture:ClearAllPoints()
	DF.baseanchor.frameTexture:SetAllPoints(DF.baseanchor.framet)
	DF.baseanchor.frameTexture:SetTexture(DF_config["anchor"..tostring(i)].texture)
	
	DF:MySetFont(DF.baseanchor.text,"Interface\\AddOns\\DroodFocus\\datas\\font.ttf",12,"OUTLINE")
	DF.baseanchor.text:SetShadowColor(0, 0, 0, 0.75)
	DF.baseanchor.text:SetShadowOffset(0.5, -0.5)
	DF.baseanchor.text:SetTextColor(1, 1, 1, 1)
	DF.baseanchor.text:SetPoint("LEFT", DF.baseanchor.overlay,"RIGHT", 0, 1)
	DF.baseanchor.text:SetText("GLOBAL")

	-- place la texture dans le cadre
	DF.baseanchor.overlay.texture = DF.baseanchor.overlayTexture
	DF.baseanchor.framet.texture = DF.baseanchor.frameTexture
	
	DF.baseanchor.frame:SetScale(DF_config["anchor"..tostring(i)].scale)
	DF.baseanchor.framet:SetScale(DF_config["anchor"..tostring(i)].scale)
	DF.baseanchor.framet:SetFrameLevel(level)
	
	DF.baseanchor.base:SetFrameLevel(10)
	
	if (DF.lock) then
		DF.baseanchor.overlay:Hide()
	end

	if DF_config["anchor"..tostring(i)].visible then
		DF.baseanchor.frame:Show()
	else
		DF.baseanchor.frame:Hide()
	end	

	-- docks anchors
	for i = 1,nbAnchors do
		
		if not DF.anchor[i] then
			
			DF.anchor[i]={}
			
			-- cadre principal
			DF.anchor[i].base = CreateFrame("FRAME","DF_anchor_BASE"..tostring(i),DF.baseanchor.base)

			-- la texture
			DF.anchor[i].frame = CreateFrame("FRAME","DF_anchor_FRAME"..tostring(i),DF.anchor[i].base)
			DF.anchor[i].framet = CreateFrame("FRAME","DF_anchor_FRAMEt"..tostring(i),DF.anchor[i].base)
			DF.anchor[i].overlay=CreateFrame("FRAME","DF_anchor_OVERLAY"..tostring(i),DF.anchor[i].base)
			DF.anchor[i].overlayTexture = DF.anchor[i].overlay:CreateTexture(nil,"BACKGROUND")
			DF.anchor[i].frameTexture = DF.anchor[i].framet:CreateTexture(nil,"BACKGROUND")
			DF.anchor[i].text = DF.anchor[i].overlay:CreateFontString("DF_ANCHORTEXT"..i,"ARTWORK")
			DF.anchor[i].base:EnableMouse(false)
			
			DF.anchor[i].overlay.numero=i
			
			DF.anchor[i].overlay:EnableMouse(false)				
			DF.anchor[i].overlay:SetScript("OnMouseDown",function(self,button)
				if button=="LeftButton" then
					DF.anchor[i].base:StartMoving()
				elseif button=="RightButton" then
					DF:options_show("dfancre"..tostring(i),DF.anchor[i].base)
				end
			end)
			DF.anchor[i].overlay:SetScript("OnMouseUp",function(self,button)
				if button=="LeftButton" then
			  		DF.anchor[i].base:StopMovingOrSizing()
			  		DF_config["anchor"..tostring(i)].positionx = DF:alignToGridX(self:GetLeft()-DF_config["anchor0"].positionx)
			  		DF_config["anchor"..tostring(i)].positiony = DF:alignToGridY(self:GetBottom()-DF_config["anchor0"].positiony)
			  		DF.anchor[i].base:ClearAllPoints()
			  		DF.anchor[i].base:SetPoint("BOTTOMLEFT", DF.baseanchor.base, "BOTTOMLEFT", DF_config["anchor"..tostring(i)].positionx, DF_config["anchor"..tostring(i)].positiony)
						DF.environnement["anchor"..tostring(self.numero).."left"]:Hide()
						DF.environnement["anchor"..tostring(self.numero).."top"]:Hide()
						DF.environnement["anchor"..tostring(self.numero).."left"]:Show()
						DF.environnement["anchor"..tostring(self.numero).."top"]:Show()
			  	end
			end)	
			DF.anchor[i].overlay:SetScript("OnEnter",function(self,button)
				if DF.configmode then
					GameTooltip:SetOwner(UIParent, "ANCHOR_TOPLEFT ",16,-16)
					GameTooltip:ClearLines()
					GameTooltip:AddLine("DROODFOCUS "..DF_config["anchor"..tostring(self.numero)].info.." ANCHOR",1,1,0,nil)
					GameTooltip:AddLine(DF.locale["leftMB"],1,1,1,nil)
					GameTooltip:AddLine(DF.locale["rightMBanchor"],1,1,1,nil)
					GameTooltip:Show()		
				end		
			end)		
			DF.anchor[i].overlay:SetScript("OnLeave",function(self,button)
				if DF.configmode then GameTooltip:Hide() end
			end)		

		end
		
		local level = DF_config["anchor"..tostring(i)].level*10

			-- paramétres cadre principal
		DF.anchor[i].base:SetMovable(true)
		DF.anchor[i].base:SetWidth(16)
		DF.anchor[i].base:SetHeight(16)
		DF.anchor[i].base:ClearAllPoints()
		DF.anchor[i].base:SetPoint("BOTTOMLEFT", DF.baseanchor.base, "BOTTOMLEFT", DF_config["anchor"..tostring(i)].positionx, DF_config["anchor"..tostring(i)].positiony)
		
			-- paramétres cadre qui acceuil éléments
		DF.anchor[i].frame:SetMovable(true)
		DF.anchor[i].frame:SetWidth(DF_config["anchor"..tostring(i)].width)
		DF.anchor[i].frame:SetHeight(DF_config["anchor"..tostring(i)].height)
		DF.anchor[i].frame:ClearAllPoints()
		DF.anchor[i].frame:SetPoint("TOPLEFT", DF.anchor[i].base, "TOPLEFT", 0, 0)

			-- paramétres cadre qui acceuil éléments
		DF.anchor[i].framet:SetMovable(true)
		DF.anchor[i].framet:SetWidth(DF_config["anchor"..tostring(i)].width)
		DF.anchor[i].framet:SetHeight(DF_config["anchor"..tostring(i)].height)
		DF.anchor[i].framet:ClearAllPoints()
		DF.anchor[i].framet:SetPoint("TOPLEFT", DF.anchor[i].base, "TOPLEFT", 0, 0)
		
		-- paramétres overlay
		DF.anchor[i].overlay:SetMovable(false)
		DF.anchor[i].overlay:SetWidth(16)
		DF.anchor[i].overlay:SetHeight(16)
		DF.anchor[i].overlay:ClearAllPoints()
		DF.anchor[i].overlay:SetPoint("TOPLEFT", DF.anchor[i].frame, "TOPLEFT", 0, 0)
		DF.anchor[i].overlay:SetFrameLevel(255)
	
		-- paramétres texture
		DF.anchor[i].overlayTexture:SetTexCoord(0, 1, 0, 1)
		DF.anchor[i].overlayTexture:SetWidth(16)
		DF.anchor[i].overlayTexture:SetHeight(16)
		DF.anchor[i].overlayTexture:SetBlendMode("BLEND")
		DF.anchor[i].overlayTexture:ClearAllPoints()
		DF.anchor[i].overlayTexture:SetAllPoints(DF.anchor[i].overlay)
		DF.anchor[i].overlayTexture:SetTexture("Interface\\AddOns\\DroodFocus\\datas\\anchor.tga")

		-- paramétres texture
		DF.anchor[i].frameTexture:SetTexCoord(0, 1, 0, 1)
		DF.anchor[i].frameTexture:SetBlendMode(DF_config["anchor"..tostring(i)].mode)
		DF.anchor[i].frameTexture:ClearAllPoints()
		DF.anchor[i].frameTexture:SetAllPoints(DF.anchor[i].framet)
		DF.anchor[i].frameTexture:SetTexture(DF_config["anchor"..tostring(i)].texture)
		
		DF:MySetFont(DF.anchor[i].text,"Interface\\AddOns\\DroodFocus\\datas\\font.ttf",12,"OUTLINE")
		DF.anchor[i].text:SetShadowColor(0, 0, 0, 0.75)
		DF.anchor[i].text:SetShadowOffset(0.5, -0.5)
		DF.anchor[i].text:SetTextColor(1, 1, 1, 1)
		DF.anchor[i].text:SetPoint("LEFT", DF.anchor[i].overlay,"RIGHT", 0, 1)
		DF.anchor[i].text:SetText(DF_config["anchor"..tostring(i)].info)

		-- place la texture dans le cadre
		DF.anchor[i].overlay.texture = DF.anchor[i].overlayTexture
		DF.anchor[i].framet.texture = DF.anchor[i].frameTexture
		
		DF.anchor[i].frame:SetScale(DF_config["anchor"..tostring(i)].scale)
		DF.anchor[i].framet:SetScale(DF_config["anchor"..tostring(i)].scale)
		DF.anchor[i].framet:SetFrameLevel(level)
		
		DF.anchor[i].base:SetFrameLevel(i*5)
		
		if (DF.lock) then
			DF.anchor[i].overlay:Hide()
		end
	
		if DF_config["anchor"..tostring(i)].visible then
			DF.anchor[i].frame:Show()
		else
			DF.anchor[i].frame:Hide()
		end
	
	end	
	
end

-- enable/disable déplacement du cadre avec la souris
function DF:anchor_toogle_lock(flag)

	DF.baseanchor.overlay:EnableMouse(flag)
	if flag then 
		DF.baseanchor.overlay:Show()
	else
		DF.baseanchor.overlay:Hide()
	end
	
	for i = 1,nbAnchors do
	
		DF.anchor[i].overlay:EnableMouse(flag)
		
		if flag then 
			DF.anchor[i].overlay:Show()
		else
			DF.anchor[i].overlay:Hide()
		end
	
	end
	
end

function DF:anchor_reinit()
	DF:init_anchor_frame()
end